unit fuAQBConnect;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, IniFiles;

type
  TfmAQBConnect = class(TForm)
	 listConnections: TListBox;
	 bAdd: TBitBtn;
	 bEdit: TBitBtn;
	 bDelete: TBitBtn;
	 bOK: TBitBtn;
	 bCancel: TBitBtn;
	 Bevel: TBevel;
	 procedure listConnectionsClick(Sender: TObject);
	 procedure FormShow(Sender: TObject);
	 procedure FormClose(Sender: TObject; var Action: TCloseAction);
	 procedure bAddClick(Sender: TObject);
	 procedure bEditClick(Sender: TObject);
	 procedure bDeleteClick(Sender: TObject);
    procedure bOKClick(Sender: TObject);
  private
	 { Private declarations }
	 IniFile: TIniFile;
  public
	 { Public declarations }
	 ConnectName: String;
	 ConnectString: String;
  end;

var
  fmAQBConnect: TfmAQBConnect;

implementation

{$R *.dfm}

uses fuAQBEditConnection;

const
	strIniFilename = 'connections.ini';
	strSection = 'Connections';
	strNewConnection = 'Connection%d';

procedure TfmAQBConnect.FormShow(Sender: TObject);
begin
	IniFile := TIniFile.Create(
		ExtractFilePath(Application.ExeName) + strIniFilename);

	IniFile.ReadSection(strSection, listConnections.Items);
	listConnectionsClick(Sender);
end;

procedure TfmAQBConnect.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
	IniFile.Free;
end;

procedure TfmAQBConnect.listConnectionsClick(Sender: TObject);
begin
	bOK.Enabled := listConnections.ItemIndex >= 0;
end;

procedure TfmAQBConnect.bAddClick(Sender: TObject);
begin
	with listConnections do begin

		with TfmAQBEditConnection.Create(Self) do try
			editName.Text := Format(strNewConnection, [ItemIndex+2]);
			if ShowModal = mrOk
			then begin
				ItemIndex := Items.Add(Trim(editName.Text));
				IniFile.WriteString(strSection, Items[ItemIndex], Trim(memoString.Text));
			end;
		finally
			Free;
		end;
	end;
end;

procedure TfmAQBConnect.bEditClick(Sender: TObject);
begin
	with listConnections do begin
		if ItemIndex = -1
			then Exit;

		with TfmAQBEditConnection.Create(Self) do try
			editName.Text := Items[ItemIndex];
			memoString.Text := IniFile.ReadString(strSection, Items[ItemIndex], '');
			if ShowModal = mrOk
			then begin
				if Trim(editName.Text) <> Items[ItemIndex]
				then begin
					IniFile.DeleteKey(strSection, Items[ItemIndex]);
					Items[ItemIndex] := Trim(editName.Text);
				end;
				IniFile.WriteString(strSection, Items[ItemIndex], Trim(memoString.Text));
			end;
		finally
			Free;
		end;
	end;
end;

procedure TfmAQBConnect.bDeleteClick(Sender: TObject);
begin
	with listConnections do begin
		if ItemIndex = -1
			then Exit;

		IniFile.DeleteKey(strSection, Items[ItemIndex]);
		Items.Delete(ItemIndex);
	end;
end;

procedure TfmAQBConnect.bOKClick(Sender: TObject);
begin
	with listConnections do begin
		if ItemIndex = -1
			then Exit;

		ConnectName := Items[ItemIndex];
		ConnectString := IniFile.ReadString(strSection, ConnectName, '');
	end;
end;

end.
